#include <time.h>

typedef unsigned long tbase;
#define NN 16
#define Loops 100000
int vvv=0;
tbase mask[NN][NN]; 

static inline int parity(const tbase ib1,int iw1,int iw2){
#if defined(__GNUC__) && defined(__i386__) && 1
    int k;tbase ib2;
    /* ib2=(ib1&~((-1)<<(2*iw2)))>>(2*(iw1+1)); */
    ib2=ib1&mask[iw1][iw2];
#if NN>32
# error Bitte PG aendern!
#endif
#if NN>16
    ib2^=ib2>>32;
#endif    
    k=1;
    asm  volatile  (			/* GNU-AS  AT&T-Syntax (!=Intel) */
         "movl %%ebx,%%eax\n\t"
         "shrl $16,%%ebx\n\t"
         "xorw %%bx,%%ax\n\t" 
         "xorb %%ah,%%al\n\t"        
         "jp 0f\n\t"			/* jump if parity-flag set */
         "subl $2,%0\n\t"		/* (%0)++;     -> long */ 
	 "0:"				/* local jump label */
       : "=r" (k) 			/* output %0 */
       : "ebx" (ib2), "0" (k) 		/* input  %1 %2 ..*/
       : "eax" , "ebx" );			/* use this registers! */
   /* r=reg, g=reg/mem, 0=output%0;  PFlag only for last 8 bits */
    return k;}
#elif 1
    tbase ib2;
    if(iw1<=iw2) ib2=(ib1&~((~0)<<(2*iw2)))>>(2*(iw1+1));
    else         ib2=(ib1&~((~0)<<(2*iw1)))>>(2*(iw2+1));
#if NN>32
# error Bitte PG aendern!
#endif
#if NN>16
    ib2^=ib2>>32;
#endif    
    ib2^=ib2>>16;    ib2^=ib2>>8;
    ib2^=ib2>>4;     ib2^=ib2>>2;
    ib2^=ib2<<1;ib2&=2;ib2--;return -ib2;}
#endif

static inline int parity2(const tbase ib1,const int iw1,const int iw2){
#if defined(__GNUC__) && defined(__i386__) && 1
    int k;tbase ib2;
/*    ib2=(ib1&~((-1)<<(2*iw2)))>>(2*(iw1+1)); */
    ib2=ib1 & mask[iw1][iw2];
#if NN>32
# error Bitte PG aendern!
#endif
#if NN>16
    ib2^=ib2>>32;
#endif    
    ib2^=ib2>>16; k=1; 
    asm ("xorb %%bh,%%bl\n\t"		/* (%1) & (%1) -> byte */
         "jp 0f\n\t"			/* jump if parity-flag set */
         "subl $2,%0\n\t"		/* (%0)++;     -> long */ 
         "0:" 
       : "=g" (k) 			/* return parameter %0 */
       : "ebx" (ib2), "0" (k) 		/* input parameter %1 %2 ..*/
       );				/* no modified registers */
   /* r=reg, g=reg/mem; P-Flag only for last 8 bits !? */
    return k;}
#elif 1
    tbase ib2;
    ib2=(ib1&~((~0)<<(2*iw2)))>>(2*(iw1+1));
#if NN>32
# error Bitte PG aendern!
#endif
#if NN>16
    ib2^=ib2>>32;
#endif    
    ib2^=ib2>>16;    ib2^=ib2>>8;
    ib2^=ib2>>4;     ib2^=ib2>>2;
    ib2^=ib2<<1;     ib2&=2;      ib2--; return -ib2;}
#endif

main(){
	long i,j1,j2;int i1,i2,is;clock_t t1,t2,t3;
	
	printf("%d %d %d\n", 1 << 1 << 2, (1<<1)<<2, 1<<(1<<2) ); 
	for(i1=0;i1<NN;i1++)for(i2=0;i2<NN;i2++)  /* nicht zeitkritisch */
	if(i1<i2) mask[i1][i2]=(~(~0 << i2 << i2)) & (~0 << i1 << i1 << 2);
	else      mask[i1][i2]=(~(~0 << i1 << i1)) & (~0 << i2 << i2 << 2);

	t1=clock();
	j1=j2=0l;t1=clock();
	for(i=0;i<Loops;i++)
	for(i1=   0;i1<NN-1;i1++)
	for(i2=i1+1;i2<NN;  i2++){
	  is=parity(i,i1,i2);
	  if(is>0)j1++; else j2++;}
	t2=clock()-t1;
	printf(" %5ld %5ld %5ld  -\n",j1,j2,(long)t2);

	t1=clock();
	j1=j2=0l;
	for(i=0;i<Loops;i++)
	for(i1=   0;i1<NN-1;i1++)
	for(i2=i1+1;i2<NN;  i2++){
	  is=parity2(i,i1,i2);
	  if(is>0)j1++; else j2++;}
	t3=clock()-t1;
	printf(" %5ld %5ld %5ld  -\n",j1,j2,(long)t3);

	for(i=0;i<Loops;i++)
	for(i1=   0;i1<NN-1;i1++)
	for(i2=i1+1;i2<NN;  i2++){
	  j1=parity(i,i1,i2);
	  j2=parity2(i,i1,i2);
	  if(j1!=j2){
	    printf("%08lx %2d %2d %+ld %+ld\n",i,i1,i2,j1,j2);
	    vvv=1;
     	    j1=parity(i,i1,i2);
	    return 1;}}
	return 0;} 
	